<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(() => {
    onPageLoad();
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoad() {
    loadCarSelect();
    loadCarTypeByCarSelect()  

    $(".btn").on("click", onBtnClicked);
  }

  function onBtnClicked() {
    var vCarSelect = $("#car-select");
    var vCarTypeSelect = $("#car-type-select");

    console.log("Brand Name: " + $( "#car-select option:selected" ).text());
    console.log("Brand Id: " + vCarSelect.val());

    console.log("Brand Type Name: " + $( "#car-type-select option:selected").text());
    console.log("Brand Type Id: " + vCarTypeSelect.val());
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadCarSelect() {
    var vCarSelect = $("#car-select");  
    
    for (var bI=0; bI < gObjectCarData.length; bI++) {    
      $("<option>", {
        html: gObjectCarData[bI].brandName,
        value: gObjectCarData[bI].brandId
      }).appendTo(vCarSelect);
    };
  }

  function loadCarTypeByCarSelect(){
    var vCarSelect = $("#car-select");
    var vCarTypeSelect = $("#car-type-select");

    vCarSelect.change(() => {      
        var carBrandTypes = getBrandTypeByBrandID(vCarSelect.val());

        if (carBrandTypes.length > 0) {
          vCarTypeSelect.prop("disabled", false);
        } else {
          vCarTypeSelect.prop("disabled", true);
        }

        vCarTypeSelect.find('option').remove().end();

        for (var bI=0; bI < carBrandTypes.length; bI++) {    
          $("<option>", {
            html: carBrandTypes[bI].typeName,
            value: carBrandTypes[bI].typeId
          }
        ).appendTo(vCarTypeSelect);
    };
    });
  };

  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }

</script> 

</html>